#!/usr/bin/perl -w

#
# copyright notice: copyright 2008 David A Thompson
#

#
# statement of copying permission:
#
# this program is distributed under the terms of the GNU
# General Public License (or the Lesser GPL) and can be
# distributed under the GNU GPL version 2 or later
#

#
# pairinsidepairs:
#
#   args: n1, n2 and array (a1,a2,b1,b2...,q1,q2,...)
#   returns: pair of numbers q1 and q2 if n1 and n2 are 'inside' the pair q1 and q2; otherwise return empty strings
#   function: a1/a2, b1/b2 represent pairs of numbers where a1 is less than or equal to a2, b1 is less than or equal to b2, etc. - pairinsidepairs asks whether n1 and n2, also a pair of numbers, is 'inside' (including the 'edges') of one of the pairs q1/a2
package DatPlUtils;
use strict;
sub pairinsidepairs
  {
    my $exitloop=0;
    my $i; # count index
    # arguments supplied to function
    my $n1;
    my $n2;
    my @pairs;
    my $m1;    # m1,m2 is ordered version of n1,n2
    my $m2;
    my $p1;  # current pair of interest from @pairs
    my $p2;
    my $pairslength;
    my $r1 = ""; # first value to return
    my $r2 = ""; # second value to return
    # get args passed to fn
    $n1=shift(@_);
    $n2=shift(@_);
    @pairs=@_;
    print "=========================\npairs: @pairs\n";
    $pairslength=@pairs;
    print "pairslength: $pairslength\n";
    # order m1 and m2 (ordered version of n1/n2) so lowest is first
    if ( $n1 < $n2 )
      { $m1 = $n1; $m2 = $n2; }
    else
      { $m1 = $n2; $m2 = $n1; }
    # look for first match
    print "pair of interest (m1/m2): $m1 and $m2\n";
    print "exitloop: $exitloop\n";
    for ( $i=0; (($i < $pairslength) &&
		 ($exitloop==0))
	  ; $i=$i+2)
      {
	# debugging: if ($i>20) {die;}
	
	# get first member of pair
	$p1 = $pairs[$i];
	$p2 = $pairs[$i+1];
	print "i: $i\nlookahead pair (p1/p2): $p1 and $p2\n";
	if ($p1 > $m2 )
	  {
	    print "found pair past m1/m2\n";
	    # we found pair which is 'past' the m1/m2 pair

	    # the pair of interest is 'one back'...
	    # get actual pair of interest:
	    $p1=$pairs[$i-2];
	    $p2=$pairs[$i-1];
	    print "comparison pair p1/p2: $p1 and $p2\n";
	    # now we need to make sure m1 and m2 are 'within' p1/p2 bracket
	    if ($m2 <= $p2 && $m1 >= $p1)
	      # we have a pair match
	      {
		$r1=$p1;
		$r2=$p2;
	      }
	    # show is over - no match
	    $exitloop=1;
	  }
      }
    # return values
    return ($r1,$r2);
  }
  1;
